## rpm 6.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

project(rpm
	VERSION 6.0.0
	DESCRIPTION "The RPM Package Manager"
	HOMEPAGE_URL "http://rpm.org"
	LANGUAGES C CXX
)

# user configurable stuff
option(ENABLE_CUTF8 "Enable C.UTF-8 as default locale" ON)
option(ENABLE_NLS "Enable native language support" ON)
option(ENABLE_OPENMP "Enable OpenMP threading support" ON)
option(ENABLE_PYTHON "Enable Python bindings" ON)
option(ENABLE_PLUGINS "Enable plugin support" ON)
option(ENABLE_WERROR "Stop build on warnings" OFF)
option(ENABLE_SQLITE "Enable sqlite rpmdb support" ON)
option(ENABLE_NDB "Enable ndb rpmdb support" ON)
option(ENABLE_BDB_RO "Enable read-only Berkeley DB rpmdb support (EXPERIMENTAL)" OFF)
option(ENABLE_TESTSUITE "Enable test-suite" OFF)
option(ENABLE_ASAN "Enable address-sanitizer" OFF)
option(ENABLE_UBSAN "Enable undefined behavior-sanitizer" OFF)

option(WITH_CAP "Build with capability support" ON)
option(WITH_ACL "Build with ACL support" ON)
option(WITH_SELINUX "Build with SELinux support" ON)
option(WITH_DBUS "Build with DBUS support" ON)
option(WITH_AUDIT "Build with audit support" ON)
option(WITH_FSVERITY "Build with fsverity support" OFF)
option(WITH_IMAEVM "Build with IMA support" OFF)
option(WITH_FAPOLICYD "Build with fapolicyd support" ON)
option(WITH_SEQUOIA "Build with Sequoia OpenPGP support" ON)
option(WITH_OPENSSL "Use openssl instead of libgcrypt for internal crypto" OFF)
option(WITH_READLINE "Build with readline support" ON)
option(WITH_BZIP2 "Build with bzip2 support" ON)
option(WITH_ICONV "Build with iconv support" ON)
option(WITH_ZSTD "Build with zstd support" ON)
option(WITH_LIBDW "Build with libdw support" ON)
option(WITH_LIBELF "Build with libelf support" ON)
option(WITH_LIBLZMA "Build with liblzma support" ON)
option(WITH_DOXYGEN "Build API docs with doxygen" OFF)

set(RPM_CONFIGDIR "${CMAKE_INSTALL_PREFIX}/lib/rpm" CACHE PATH "rpm home")
set(RPM_MACROSDIR "${RPM_CONFIGDIR}/macros.d")
set(RPM_VENDOR "vendor" CACHE STRING "rpm vendor string")

# Emulate libtool versioning. Before a public release:
# - increment micro version whenever there are code changes
# - increment minor version whenever there are added interfaces
# - increment major version whenever there are removed interfaces
# - incrementing a more significant version segment resets changes to
#   any less significant segments
set(RPM_SOVERSION 10)
set(RPM_LIBVERSION ${RPM_SOVERSION}.6.0)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
# extensions needed for typeof() hacks during transition
set(CMAKE_CXX_EXTENSIONS ON)
set(CMAKE_SHARED_LIBRARY_PREFIX "")
set(CMAKE_SHARED_MODULE_PREFIX "")
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
include(GNUInstallDirs)
include(CheckSymbolExists)
add_compile_definitions(_GNU_SOURCE)
add_definitions(-D_FILE_OFFSET_BITS=64)

# Find a (system) utility in canonical FHS paths, excluding $PATH.  Useful for
# when the path is to be used at RPM runtime, such as in the macro files.  The
# MYPATH environment variable can be used to augment these paths.
function(findutil UTIL TRY)
	list(GET TRY 0 util)
	find_program(${UTIL}
		NAMES ${TRY}
		PATHS ENV MYPATH
		PATHS /usr/local/bin /usr/bin /bin
		PATHS /usr/local/sbin /usr/sbin /sbin
		NO_DEFAULT_PATH
	)
	if (NOT ${UTIL})
		list(GET TRY 0 util)
		message(DEBUG "${util} not found, assuming /usr/bin/${util}")
		set(${UTIL} /usr/bin/${util} PARENT_SCOPE)
	endif()
	mark_as_advanced(${UTIL})
endfunction()

function(makemacros)
	set(prefix ${CMAKE_INSTALL_PREFIX})
	set(exec_prefix "\${prefix}")
	set(bindir "\${exec_prefix}/${CMAKE_INSTALL_BINDIR}")
	set(sbindir "\${exec_prefix}/${CMAKE_INSTALL_SBINDIR}")
	set(libexecdir "\${exec_prefix}/${CMAKE_INSTALL_LIBEXECDIR}")
	set(datarootdir "\${prefix}/${CMAKE_INSTALL_DATAROOTDIR}")
	set(datadir "\${datarootdir}")
	set(sysconfdir "${CMAKE_INSTALL_FULL_SYSCONFDIR}")
	set(sharedstatedir "${CMAKE_INSTALL_FULL_SHAREDSTATEDIR}")
	set(localstatedir "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}")
	set(libdir "\${prefix}/=LIB=")
	set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
	set(oldincludedir "${CMAKE_INSTALL_FULL_OLDINCLUDEDIR}")
	set(infodir "\${prefix}/${CMAKE_INSTALL_INFODIR}")
	set(mandir "\${prefix}/${CMAKE_INSTALL_MANDIR}")
	set(rundir /run)

	pkg_get_variable(sysusersdir systemd sysusersdir)
	if (NOT sysusersdir)
		set(sysusersdir /usr/lib/sysusers.d)
	endif()

	findutil(__7ZIP "7za;7z")
	findutil(__BZIP2 bzip2)
	findutil(__CAT cat)
	findutil(__CHMOD chmod)
	findutil(__CHOWN chown)
	findutil(__CP cp)
	findutil(__CURL curl)
	findutil(__FILE file)
	findutil(__GPG gpg)
	findutil(__GREP grep)
	findutil(__GZIP gzip)
	findutil(__ID id)
	findutil(__CC cc)
	findutil(__LN ln)
	findutil(__INSTALL install)
	findutil(__LRZIP lrzip)
	findutil(__LZIP lzip)
	findutil(__XZ xz)
	findutil(__MAKE make)
	findutil(__MKDIR mkdir)
	findutil(__MV mv)
	findutil(__PATCH patch)
	findutil(__RM rm)
	findutil(__SED sed)
	findutil(__TAR tar)
	findutil(__UNZIP unzip)
	findutil(__ZSTD zstd)
	findutil(__GEM gem)
	findutil(__GIT git)
	findutil(__HG hg)
	findutil(__BZR bzr)
	findutil(__QUILT quilt)
	findutil(__LD ld)
	findutil(__OBJDUMP objdump)
	findutil(__STRIP strip)
	findutil(__SYSTEMD_SYSUSERS systemd-sysusers)
	findutil(__FIND_DEBUGINFO find-debuginfo)
	findutil(__AWK awk)
	findutil(__AR ar)
	findutil(__AS as)
	findutil(__CPP cpp)
	findutil(__CXX c++)
	findutil(__SQ sq)

	list(GET db_backends 0 DB_BACKEND)

	set(host_cpu ${CMAKE_HOST_SYSTEM_PROCESSOR})
	string(TOLOWER ${CMAKE_HOST_SYSTEM_NAME} host_os)
	set(host_vendor ${RPM_VENDOR})
	set(host ${host_cpu}-${host_vendor}-${host_os})

	set(RPMCANONVENDOR ${host_vendor})
	set(RPMCANONOS ${host_os})
	set(RPMCANONGNU -gnu)

	configure_file(platform.in platform @ONLY)
	configure_file(rpmrc.in rpmrc @ONLY)
	configure_file(macros.in macros @ONLY)
	configure_file(rpmpopt.in rpmpopt-${PROJECT_VERSION} @ONLY)
	configure_file(rpm.pc.in rpm.pc @ONLY)

	install(CODE "execute_process(COMMAND
		${CMAKE_COMMAND} -E env pkglibdir=${RPM_CONFIGDIR}
			${CMAKE_SOURCE_DIR}/installplatform
			rpmrc platform macros
			${RPMCANONVENDOR} ${RPMCANONOS} ${RPMCANONGNU}
		WORKING_DIRECTORY ${CMAKE_BINARY_DIR})"
	)
endfunction()

include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckVariableExists)

set(OPTFUNCS
	stpcpy stpncpy putenv mempcpy fdatasync lutimes mergesort
	getauxval setprogname __progname syncfs sched_getaffinity unshare
	secure_getenv __secure_getenv mremap strchrnul
)
set(REQFUNCS
	mkstemp getcwd basename dirname realpath setenv unsetenv regcomp
	utimes getline localtime_r statvfs getaddrinfo
	openat mkdirat fstatat linkat symlinkat mkfifoat mknodat unlinkat
	renameat utimensat fchmodat fchownat stpcpy stpncpy
)

find_package(PkgConfig REQUIRED)
find_package(Lua 5.2 REQUIRED)
find_package(ZLIB REQUIRED)
if (WITH_BZIP2)
    find_package(BZip2 REQUIRED)
endif()
if (WITH_ICONV)
    find_package(Iconv REQUIRED)
endif()

pkg_check_modules(POPT REQUIRED IMPORTED_TARGET popt)

if (WITH_READLINE)
    pkg_check_modules(READLINE REQUIRED IMPORTED_TARGET readline)
endif()

if (WITH_ZSTD)
    pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET libzstd>=1.3.8)
endif()
if (WITH_LIBELF)
    pkg_check_modules(LIBELF REQUIRED IMPORTED_TARGET libelf)
endif()
if (WITH_LIBDW)
    pkg_check_modules(LIBDW REQUIRED IMPORTED_TARGET libdw)
endif()
if (WITH_LIBLZMA)
    pkg_check_modules(LIBLZMA REQUIRED IMPORTED_TARGET liblzma>=5.2.0)
endif()
pkg_check_modules(LIBARCHIVE REQUIRED IMPORTED_TARGET libarchive)

# Lua module does not ship an IMPORTED target, define our own
add_library(LUA::LUA INTERFACE IMPORTED)
set_target_properties(LUA::LUA PROPERTIES
		      INTERFACE_LINK_LIBRARIES "${LUA_LIBRARIES}"
		      INTERFACE_INCLUDE_DIRECTORIES "${LUA_INCLUDE_DIR}")

# file >= 5.39 ships a pkg-config, may move to that later
add_library(MAGIC::MAGIC UNKNOWN IMPORTED)
find_library(MAGIC_LIBRARY NAMES magic REQUIRED)
find_path(MAGIC_INCLUDE_DIR NAMES magic.h REQUIRED)
mark_as_advanced(MAGIC_LIBRARY)
mark_as_advanced(MAGIC_INCLUDE_DIR)
set_target_properties(MAGIC::MAGIC PROPERTIES
		      IMPORTED_LOCATION "${MAGIC_LIBRARY}")
target_include_directories(MAGIC::MAGIC INTERFACE "${MAGIC_INCLUDE_DIR}")

if (ENABLE_OPENMP)
	find_package(OpenMP 4.5 REQUIRED)
endif()

if (ENABLE_NLS)
	find_package(Intl REQUIRED)
	check_variable_exists(_nl_msg_cat_cntr HAVE_NL_MSG_CAT_CNTR)
endif()

if (ENABLE_SQLITE)
	pkg_check_modules(SQLITE REQUIRED IMPORTED_TARGET sqlite3>=3.22)
	list(APPEND db_backends sqlite)
endif()

if (ENABLE_NDB)
	list(APPEND db_backends ndb)
endif()

if (ENABLE_BDB_RO)
	list(APPEND db_backends bdb_ro)
endif()
list(APPEND db_backends dummy)

if (ENABLE_PYTHON)
	find_package(Python3 3.10 COMPONENTS Interpreter Development REQUIRED)
endif()

if (WITH_CAP)
	pkg_check_modules(LIBCAP REQUIRED IMPORTED_TARGET libcap)
endif()

if (WITH_ACL)
	pkg_check_modules(LIBACL REQUIRED IMPORTED_TARGET libacl)
endif()

if (WITH_AUDIT)
	pkg_check_modules(AUDIT REQUIRED IMPORTED_TARGET audit)
endif()

if (WITH_SELINUX)
	pkg_check_modules(SELINUX REQUIRED IMPORTED_TARGET libselinux)
endif()

if (WITH_FSVERITY)
	pkg_check_modules(FSVERITY REQUIRED IMPORTED_TARGET libfsverity)
endif()

if (WITH_IMAEVM)
	list(APPEND REQFUNCS lsetxattr)
	check_library_exists(imaevm imaevm_signhash "" HAVE_IMAEVM_SIGNHASH)
	add_library(IMA::IMA UNKNOWN IMPORTED)
	find_path(IMA_INCLUDE_DIR NAMES imaevm.h REQUIRED)
	find_library(IMA_LIBRARY NAMES imaevm REQUIRED)
	mark_as_advanced(IMA_INCLUDE_DIR)
	mark_as_advanced(IMA_LIBRARY)
	set_target_properties(IMA::IMA PROPERTIES
			      IMPORTED_LOCATION "${IMA_LIBRARY}")
	target_include_directories(IMA::IMA INTERFACE "${IMA_INCLUDE_DIR}")
endif()

find_program(AWK gawk mawk nawk awk REQUIRED)
mark_as_advanced(AWK)

find_program(FIND_DEBUGINFO find-debuginfo)
mark_as_advanced(FIND_DEBUGINFO)

find_program(PODMAN podman)
mark_as_advanced(PODMAN)

find_program(SCDOC NAMES scdoc REQUIRED)
mark_as_advanced(SCDOC)

find_program(SCD2HTML NAMES scd2html)
mark_as_advanced(SCD2HTML)

function(chkdef func req)
	string(TOUPPER ${func} FUNC)
	set(HAVENAME HAVE_${FUNC})
	check_function_exists(${func} ${HAVENAME})
	if (${req} AND NOT ${HAVENAME})
		message(FATAL_ERROR "required function ${func} not found")
	endif()
endfunction()

foreach(f ${OPTFUNCS})
    chkdef(${f} FALSE)
endforeach()

foreach(f ${REQFUNCS})
    chkdef(${f} TRUE)
endforeach()

function(chkhdr inc req)
	string(MAKE_C_IDENTIFIER ${inc} ID)
	string(TOUPPER ${ID} INC)
	set(HAVENAME HAVE_${INC})
	check_include_file(${inc} ${HAVENAME})
	if (${req} AND NOT ${HAVENAME})
		message(FATAL_ERROR "required include ${inc} not found")
	endif()
endfunction()

set(OPTINCS
	unistd.h limits.h getopt.h
	sys/utsname.h sys/systemcfg.h sys/param.h sys/auxv.h
)
foreach(f ${OPTINCS})
    chkhdr(${f} FALSE)
endforeach()

function(id0name var file)
	execute_process(COMMAND ${AWK} -F: "$3==0 {print $1;exit}" ${file}
			OUTPUT_STRIP_TRAILING_WHITESPACE
			OUTPUT_VARIABLE name)
	if ("${name}" STREQUAL "")
		set(name root)
	endif()
	set(${var} ${name} PARENT_SCOPE)
endfunction()

id0name(UID_0_USER /etc/passwd)
id0name(GID_0_GROUP /etc/group)

# map module/package findings to config.h
if (BZIP2_FOUND)
	set(HAVE_BZLIB_H 1)
endif()
if (LIBLZMA_FOUND)
	set(HAVE_LZMA_H 1)
endif()
if (Iconv_FOUND)
	set(HAVE_ICONV 1)
endif()
if (ZSTD_FOUND)
	set(HAVE_ZSTD 1)
endif()
if (READLINE_FOUND)
	set(HAVE_READLINE 1)
endif()
if (LIBELF_FOUND)
	set(HAVE_LIBELF 1)
endif()
if (LIBDW_FOUND)
	set(HAVE_LIBDW 1)
	check_library_exists(dw dwelf_elf_begin "" HAVE_DWELF_ELF_BEGIN)
endif()

check_symbol_exists(GLOB_ONLYDIR "glob.h" HAVE_GLOB_ONLYDIR)
check_symbol_exists(major "sys/sysmacros.h" MAJOR_IN_SYSMACROS)
if (NOT MAJOR_IN_SYSMACROS)
	check_symbol_exists(major "sys/mkdev.h" MAJOR_IN_MKDEV)
endif()

if (ENABLE_CUTF8)
	set(C_LOCALE "C.UTF-8")
else()
	set(C_LOCALE "C")
endif()
message(INFO " using ${C_LOCALE} as default locale")

=== build/CMakeLists.txt ===
add_library(librpmbuild SHARED)
set_target_properties(librpmbuild PROPERTIES
	VERSION ${RPM_LIBVERSION}
	SOVERSION ${RPM_SOVERSION}
)
target_sources(librpmbuild PRIVATE
	build.cc files.cc misc.cc pack.cc
	parseSimpleScript.cc parseChangelog.cc parseDescription.cc
	parseFiles.cc parsePreamble.cc parsePrep.cc parseReqs.cc parseScript.cc
	parseSpec.cc parseList.cc reqprov.cc rpmfc.cc spec.cc
	parsePolicies.cc policies.cc
	rpmbuild_internal.hh rpmbuild_misc.hh
	speclua.cc
)

target_include_directories(librpmbuild
    PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/rpmio
	${CMAKE_SOURCE_DIR}/lib
	${Intl_INCLUDE_DIRS}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(librpmbuild PUBLIC librpmio librpm librpmsign)
target_link_libraries(librpmbuild PRIVATE
	libmisc
	PkgConfig::POPT
	LUA::LUA
	MAGIC::MAGIC
	${Intl_LIBRARIES}
)

if (LIBDW_FOUND)
	target_link_libraries(librpmbuild PRIVATE PkgConfig::LIBDW)
endif()

if (LIBELF_FOUND)
	target_link_libraries(librpmbuild PRIVATE PkgConfig::LIBELF)
endif()

if (Iconv_FOUND)
	target_link_libraries(librpmbuild PRIVATE Iconv::Iconv)
endif()

if(WITH_CAP)
	target_link_libraries(librpmbuild PRIVATE PkgConfig::LIBCAP)
endif()

if(OpenMP_C_FOUND)
	target_link_libraries(librpmbuild PRIVATE OpenMP::OpenMP_C)
endif()

if (OpenMP_C_FOUND)
	target_link_libraries(librpmbuild PRIVATE OpenMP::OpenMP_CXX)
endif()

install(TARGETS librpmbuild EXPORT rpm-targets)

=== fileattrs/CMakeLists.txt ===
install(FILES
	debuginfo.attr desktop.attr elf.attr font.attr metainfo.attr
	pkgconfig.attr ocaml.attr
	rpm_macro.attr rpm_lua.attr script.attr sysusers.attr usergroup.attr
	DESTINATION ${RPM_CONFIGDIR}/fileattrs
)

=== lib/CMakeLists.txt ===
add_library(librpm SHARED)
set_target_properties(librpm PROPERTIES
	VERSION ${RPM_LIBVERSION}
	SOVERSION ${RPM_SOVERSION}
)

target_compile_definitions(librpm PRIVATE
	LOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
	LOCALSTATEDIR="${CMAKE_INSTALL_FULL_LOCALSTATEDIR}"
	SYSCONFDIR="${CMAKE_INSTALL_FULL_SYSCONFDIR}"
	LIBRPMALIAS_FILENAME="rpmpopt-${PROJECT_VERSION}"
	LIBRPMALIAS_EXECPATH="${CMAKE_INSTALL_FULL_BINDIR}"
)

target_include_directories(librpm
    PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/rpmio
	${CMAKE_CURRENT_BINARY_DIR}
	${Intl_INCLUDE_DIRS}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        # This is needed for rpmcli.hh
        ${POPT_INCLUDE_DIRS}
)

target_sources(librpm PRIVATE
	backend/dbi.cc backend/dbi.hh backend/dummydb.cc
	backend/dbiset.cc backend/dbiset.hh
	headerutil.cc header.cc headerfmt.cc header_internal.hh
	keystore.cc keystore.hh
	rpmdb.cc rpmdb_internal.hh
	fprint.cc fprint.hh tagname.cc rpmtd.cc tagtbl.inc
	cpio.cc cpio.hh depends.cc order.cc formats.cc tagexts.cc fsm.cc fsm.hh
	manifest.cc manifest.hh package.cc
	poptALL.cc poptI.cc poptQV.cc psm.cc query.cc
	rpmal.cc rpmal.hh rpmchecksig.cc rpmds.cc rpmds_internal.hh
	rpmfi.cc rpmfi_internal.hh
	rpmgi.hh rpmgi.cc rpminstall.cc rpmts_internal.hh
	rpmlead.cc rpmlead.hh rpmps.cc rpmprob.cc rpmrc.cc
	rpmte.cc rpmte_internal.hh rpmts.cc rpmfs.hh rpmfs.cc
	signature.cc signature.hh transaction.cc
	verify.cc rpmlock.cc rpmlock.hh misc.hh relocation.cc
	rpmscript.hh rpmscript.cc
	rpmchroot.cc rpmchroot.hh
	rpmplugins.cc rpmplugins.hh rpmug.cc rpmug.hh
	rpmtriggers.hh rpmtriggers.cc rpmvs.cc rpmvs.hh
)

if(ENABLE_SQLITE)
	target_sources(librpm PRIVATE backend/sqlite.cc)
	target_link_libraries(librpm PRIVATE PkgConfig::SQLITE)
endif()

if(ENABLE_NDB)
	target_sources(librpm PRIVATE
		backend/ndb/glue.cc
		backend/ndb/rpmpkg.c backend/ndb/rpmpkg.h
		backend/ndb/rpmidx.c backend/ndb/rpmidx.h
		backend/ndb/rpmxdb.c backend/ndb/rpmxdb.h
	)
endif()

if(ENABLE_BDB_RO)
	target_sources(librpm PRIVATE backend/bdb_ro.cc)
endif()

if(WITH_ACL)
	target_link_libraries(librpm PRIVATE PkgConfig::LIBACL)
endif()

if(WITH_CAP)
	target_link_libraries(librpm PRIVATE PkgConfig::LIBCAP)
endif()

add_custom_command(OUTPUT tagtbl.inc
	COMMAND AWK=${AWK} ${CMAKE_CURRENT_SOURCE_DIR}/gentagtbl.sh ${CMAKE_SOURCE_DIR}/include/rpm/rpmtag.h > tagtbl.inc
	DEPENDS ${CMAKE_SOURCE_DIR}/include/rpm/rpmtag.h gentagtbl.sh
)

target_link_libraries(librpm PUBLIC librpmio)
target_link_libraries(librpm PRIVATE PkgConfig::POPT LUA::LUA ${Intl_LIBRARIES})

install(TARGETS librpm EXPORT rpm-targets)

=== misc/CMakeLists.txt ===
add_library(libmisc OBJECT fts.c rpmfts.h)
target_include_directories(libmisc PRIVATE ${Intl_INCLUDE_DIRS})

=== python/CMakeLists.txt ===
Python3_add_library(_rpm
	rpmmodule.c rpmsystem-py.h
	header-py.c header-py.h
	rpmarchive-py.c rpmarchive-py.h
	rpmds-py.c rpmds-py.h
	rpmfd-py.c rpmfd-py.h
	rpmfiles-py.c rpmfiles-py.h
	rpmkeyring-py.c rpmkeyring-py.h
	rpmmi-py.c rpmmi-py.h
	rpmii-py.c rpmii-py.h
	rpmps-py.c rpmps-py.h
	rpmmacro-py.c rpmmacro-py.h
	rpmstrpool-py.c rpmstrpool-py.h
	rpmtd-py.c rpmtd-py.h
	rpmte-py.c rpmte-py.h
	rpmts-py.c rpmts-py.h
	rpmver-py.c rpmver-py.h
	spec-py.c spec-py.h
)

# Select Python stable ABI
target_compile_definitions(_rpm PRIVATE Py_LIMITED_API=0x030A0000)

target_link_libraries(_rpm PRIVATE librpmio librpm librpmbuild librpmsign)

install(TARGETS _rpm
	DESTINATION ${Python3_SITEARCH}/rpm)
install(FILES rpm/transaction.py rpm/__init__.py
	DESTINATION ${Python3_SITEARCH}/rpm)
install(DIRECTORY examples TYPE DOC)

set(egginfo ${PROJECT_NAME}-${PROJECT_VERSION}-py${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}.egg-info)
configure_file(rpm.egg-info.in ${egginfo} @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${egginfo}
	DESTINATION ${Python3_SITEARCH})

=== rpmio/CMakeLists.txt ===
add_library(librpmio SHARED)

target_sources(librpmio PRIVATE
	argv.cc base64.cc digest.cc expression.cc macro.cc rpmhook.hh rpmhook.cc
	rpmio.cc rpmlog.cc rpmmalloc.cc rgetopt.cc rpmpgp.cc rpmpgpval.hh
	rpmsq.cc rpmsw.cc url.cc rpmio_internal.hh rpmvercmp.cc
	rpmver.cc rpmstring.cc rpmfileutil.cc rpmglob.cc rpmkeyring.cc
	rpmstrpool.cc rpmmacro_internal.hh rpmlua.cc rpmlua.hh lposix.cc
)
target_compile_definitions(librpmio PRIVATE RPM_CONFIGDIR="${RPM_CONFIGDIR}")
target_include_directories(librpmio 
    PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${Intl_INCLUDE_DIRS}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

if (EXISTS ${CMAKE_SOURCE_DIR}/rpmio/rpmpgp_legacy/CMakeLists.txt)
	add_subdirectory(rpmpgp_legacy)
endif()

if (WITH_SEQUOIA)
	pkg_check_modules(RPMSEQUOIA REQUIRED IMPORTED_TARGET rpm-sequoia>=1.9.0)
	target_sources(librpmio PRIVATE rpmpgp_sequoia.cc)
	target_link_libraries(librpmio PRIVATE PkgConfig::RPMSEQUOIA)
else()
	if (WITH_LEGACY_OPENPGP)
		target_link_libraries(librpmio PRIVATE rpmpgp_legacy)
	else()
		target_sources(librpmio PRIVATE rpmpgp_dummy.cc)
	endif()
	if (WITH_OPENSSL)
		find_package(OpenSSL 1.0.2 REQUIRED)
		target_sources(librpmio PRIVATE digest_openssl.cc)
		target_link_libraries(librpmio PRIVATE OpenSSL::Crypto)
	else()
		pkg_check_modules(LIBGCRYPT REQUIRED IMPORTED_TARGET libgcrypt)
		target_sources(librpmio PRIVATE digest_libgcrypt.cc)
		target_link_libraries(librpmio PRIVATE PkgConfig::LIBGCRYPT)
	endif()
endif()

set_target_properties(librpmio PROPERTIES
	VERSION ${RPM_LIBVERSION}
	SOVERSION ${RPM_SOVERSION}
)
target_link_libraries(librpmio PRIVATE
	PkgConfig::POPT
	LUA::LUA
	ZLIB::ZLIB
	${Intl_LIBRARIES}
)

if (ZSTD_FOUND)
	target_link_libraries(librpmio PRIVATE PkgConfig::ZSTD)
endif()
if (LIBLZMA_FOUND)
	target_link_libraries(librpmio PRIVATE PkgConfig::LIBLZMA)
endif()
if (BZIP2_FOUND)
	target_link_libraries(librpmio PRIVATE BZip2::BZip2)
endif()
if (OpenMP_C_FOUND)
        target_link_libraries(librpmio PRIVATE OpenMP::OpenMP_C)
endif()

install(TARGETS librpmio EXPORT rpm-targets)

=== scripts/CMakeLists.txt ===
install(PROGRAMS gendiff TYPE BIN)
install(PROGRAMS
	brp-compress brp-strip brp-strip-comment-note
	brp-strip-static-archive brp-remove-la-files
	check-files check-prereqs
	check-buildroot check-rpaths check-rpaths-worker
	find-lang.sh find-requires find-provides
	pkgconfigdeps.sh
	ocamldeps.sh
	fontconfig.prov script.req
	rpm_macros_provides.sh
	rpmdb_dump rpmdb_load
	rpm2cpio.sh tgpg
	sysusers.sh rpm-setup-autosign
	DESTINATION ${RPM_CONFIGDIR}
)
install(FILES
	rpm.daily rpm.log rpm.supp
	DESTINATION ${RPM_CONFIGDIR}
)

=== sign/CMakeLists.txt ===
add_library(librpmsign SHARED)
set_target_properties(librpmsign PROPERTIES
	VERSION ${RPM_LIBVERSION}
	SOVERSION ${RPM_SOVERSION}
)
target_sources(librpmsign PRIVATE rpmgensig.cc)

target_include_directories(librpmsign
    PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/rpmio
	${CMAKE_SOURCE_DIR}/lib
	${Intl_INCLUDE_DIRS}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(librpmsign PUBLIC librpmio librpm)
target_link_libraries(librpmsign PRIVATE PkgConfig::POPT ${Intl_LIBRARIES})
if (WITH_IMAEVM)
	target_sources(librpmsign PRIVATE rpmsignfiles.cc)
	target_link_libraries(librpmsign PRIVATE IMA::IMA)
endif()
if (WITH_FSVERITY)
	target_sources(librpmsign PRIVATE rpmsignverity.cc)
	target_link_libraries(librpmsign PRIVATE PkgConfig::FSVERITY)
endif()

install(TARGETS librpmsign EXPORT rpm-targets)

=== tests/CMakeLists.txt ===
# Use our cli tools as an ordering clue to cmake: the project
# needs to be built before we can populate anything. The tools depend
# on all the libraries so we get a good coverage.
get_property(TOOLPROGS DIRECTORY ../tools PROPERTY BUILDSYSTEM_TARGETS)

function(os_release var key)
	execute_process(
		COMMAND sh -c ". /etc/os-release; echo $${key}"
		OUTPUT_STRIP_TRAILING_WHITESPACE
		OUTPUT_VARIABLE value
	)
	string(TOLOWER ${value} value)
	set(${var} ${value} PARENT_SCOPE)
endfunction()

set(PYTHON ${Python3_EXECUTABLE})
if (WITH_SEQUOIA)
	set(PGP sequoia)
elseif (WITH_LEGACY_OPENPGP)
	set(PGP legacy)
else()
	set(PGP dummy)
endif()
set(HAVE_UNSHARE ${HAVE_UNSHARE})

set(TESTSUITE_AT
	rpmpgp.at
	rpmgeneral.at
	rpmvercmp.at
	rpmmacro.at
	rpmapi.at
	rpmdevel.at
	rpmpython.at
	rpmpython2.at
	rpmdepmatch.at
	rpmquery.at
	rpmspec.at
	rpmvfylevel.at
	rpmsigdig.at
	rpmpkgfmt.at
	rpmio.at
	rpmverify.at
	rpmdb.at
	rpmi.at
	rpme.at
	rpmorder.at
	rpmbuild.at
	rpmbuildid.at
	rpmscript.at
	rpmdeps.at
	rpmconflict.at
	rpmreplace.at
	rpmconfig.at
	rpmconfig2.at
	rpmconfig3.at
	rpmbrp.at
)

FILE(REMOVE ${CMAKE_CURRENT_BINARY_DIR}/rpmtests.at)
FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/rpmtests.at "m4_define([RPM_PGP], [${PGP}])\n")
foreach(at ${TESTSUITE_AT})
	FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/rpmtests.at "m4_include([${at}])\n")
endforeach()

set(TESTPROGS rpmpgpcheck rpmpgppubkeyfingerprint readpkgnullts rpmdig)
foreach(prg ${TESTPROGS})
	add_executable(${prg} EXCLUDE_FROM_ALL ${prg}.c)
	target_link_libraries(${prg} PRIVATE librpm)
endforeach()
string(REPLACE ";" " " TESTPROG_NAMES "${TESTPROGS}")

set(PINNED_DIR ${CMAKE_CURRENT_SOURCE_DIR}/pinned)

include(ProcessorCount)
ProcessorCount(nproc)
if (nproc GREATER 1)
	set(JOBS -j${nproc})
endif()

# Set up mktree
set(MKTREE_BACKEND oci CACHE STRING "Mktree backend to use")
if (MKTREE_BACKEND STREQUAL oci)
	find_program(PODMAN podman)
	find_program(DOCKER docker)
	mark_as_advanced(PODMAN DOCKER)
	os_release(OS_NAME ID)
	os_release(OS_VERSION VERSION_ID)
	set(DOCKERFILE ${CMAKE_CURRENT_SOURCE_DIR}/Dockerfile.${OS_NAME})
	if (PODMAN AND EXISTS ${DOCKERFILE})
		set(MKTREE_NATIVE yes)
		configure_file(${DOCKERFILE} Dockerfile COPYONLY)
		add_custom_target(ci
			COMMAND ./mktree.oci build
			COMMAND ./mktree.oci check ${JOBS} $(TESTOPTS)
			COMMAND ./mktree.oci clean
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	else()
		set(MKTREE_NATIVE no)
		configure_file(Dockerfile Dockerfile COPYONLY)
	endif()
	find_program(PODMAN NAMES podman docker REQUIRED)
elseif (MKTREE_BACKEND STREQUAL rootfs)
	set(MKTREE_NATIVE yes)
	find_program(BWRAP bwrap REQUIRED)
	mark_as_advanced(BWRAP)
endif()
message(STATUS "Using mktree backend: ${MKTREE_BACKEND} "
	       "(native: ${MKTREE_NATIVE})")
configure_file(mktree.common mktree.common @ONLY)
configure_file(mktree.${MKTREE_BACKEND} mktree @ONLY)
configure_file(setup.sh setup.sh @ONLY)

if (MKTREE_NATIVE)
	find_program(AUTOM4TE autom4te REQUIRED)
	mark_as_advanced(AUTOM4TE)
	set(AUTOTEST ${AUTOM4TE} --language=autotest)

	configure_file(atlocal.in atlocal @ONLY)
	configure_file(package.m4.in package.m4 @ONLY)

	add_custom_command(OUTPUT rpmtests
		COMMAND ${AUTOTEST} -I ${CMAKE_CURRENT_SOURCE_DIR}
			-o rpmtests rpmtests.at
		DEPENDS ${TESTSUITE_AT} rpmtests.at
		DEPENDS local.at
	)

	add_custom_target(tree
		COMMAND ./mktree build
		DEPENDS rpmtests
		DEPENDS ${TESTPROGS}
		DEPENDS ${TOOLPROGS}
	)
else()
	add_custom_target(tree COMMAND ./mktree build)
endif()

add_custom_target(atshell
	COMMAND ./mktree atshell ||:
	COMMAND ./mktree clean
	DEPENDS tree
)

add_custom_target(pinned
	COMMAND ./mktree atshell /pinned/update
	COMMAND cp pinned/*.txt ${PINNED_DIR}/
	COMMAND git add ${PINNED_DIR}/*.txt
	COMMAND git diff --staged ${PINNED_DIR}/*.txt
	COMMAND ./mktree clean
	DEPENDS tree
)

add_custom_target(shell
	COMMAND ./mktree shell ||:
	COMMAND ./mktree clean
	DEPENDS tree
)

add_custom_target(check
	COMMAND ./mktree check ${JOBS} $(TESTOPTS)
	COMMAND ./mktree clean
	DEPENDS tree
)

add_custom_target(reset
	COMMAND ./mktree reset
)

=== docs/man/CMakeLists.txt ===
set(core
	gendiff.1 rpm2cpio.1 rpm2archive.1 rpmuncompress.1
	rpm.8 rpmbuild.1 rpmdb.8 rpmkeys.8 rpmsign.1 rpmspec.1
	rpmdeps.1 rpmgraph.1 rpmlua.1 rpm-common.8 rpmsort.1
	rpm-macrofile.5 rpm-config.5 rpm-rpmrc.5 rpm-setup-autosign.1
	rpm-payloadflags.7 rpmbuild-config.5 rpm-queryformat.7 rpm-macros.7
	rpm-lua.7 rpm-manifest.5 rpm-version.7
)
set(extra
	rpm-plugins.8 rpm-plugin-prioreset.8 rpm-plugin-syslog.8
	rpm-plugin-audit.8 rpm-plugin-dbus-announce.8
	rpm-plugin-systemd-inhibit.8 rpm-plugin-fapolicyd.8 rpm-plugin-ima.8
	rpm-plugin-selinux.8 rpm-plugin-unshare.8
)

# Build all manuals
set(manuals ${core} ${extra})
foreach(man ${manuals})
	add_custom_command(OUTPUT ${man} COMMAND
			sed '1 s/$$/ \"RPM ${CMAKE_PROJECT_VERSION}\"/'
			< ${CMAKE_CURRENT_SOURCE_DIR}/${man}.scd | ${SCDOC}
			> ${man} DEPENDS ${man}.scd)
endforeach()
add_custom_target(man ALL DEPENDS ${manuals})

# Render Jekyll-ready HTML pages from the manuals
if (SCD2HTML)
	configure_file(mkpage.in mkpage @ONLY)
	set(manuals_html "")
	foreach(man ${manuals})
		set(file ${site_dir}/man/${man}.html)
		list(APPEND manuals_html ${file})
		add_custom_command(OUTPUT ${file} COMMAND ./mkpage
				${CMAKE_CURRENT_SOURCE_DIR}/${man}.scd ${file}
				DEPENDS ${man}.scd mkpage)
	endforeach()
	add_custom_target(clidoc DEPENDS ${manuals_html})
	add_dependencies(pages clidoc)
endif()

# Install manuals for the enabled features
set(manuals ${core})
if (ENABLE_PLUGINS)
	list(APPEND manuals rpm-plugins.8
		rpm-plugin-prioreset.8 rpm-plugin-syslog.8)
	if (WITH_AUDIT)
		list(APPEND manuals rpm-plugin-audit.8)
	endif()
	if (WITH_DBUS)
		list(APPEND manuals
			rpm-plugin-dbus-announce.8 rpm-plugin-systemd-inhibit.8)
	endif()
	if (WITH_FAPOLICYD)
		list(APPEND manuals rpm-plugin-fapolicyd.8)
	endif()
	if (WITH_IMAEVM)
		list(APPEND manuals rpm-plugin-ima.8)
	endif()
	if (WITH_SELINUX)
		list(APPEND manuals rpm-plugin-selinux.8)
	endif()
	if (HAVE_UNSHARE)
		list(APPEND manuals rpm-plugin-unshare.8)
	endif()
endif()
foreach(man ${manuals})
	set(fn ${CMAKE_CURRENT_BINARY_DIR}/${man})
	get_filename_component(ext ${fn} EXT)
	string(REPLACE "." "man" section ${ext})
	install(FILES ${fn}
		DESTINATION ${CMAKE_INSTALL_MANDIR}/${section})
endforeach()

=== debian/changelog ===
rpm (6.0.0-2) unstable; urgency=medium

  * macros: do not verify signatures by default

 -- Luca Boccassi <bluca@debian.org>  Fri, 07 Nov 2025 00:56:15 +0000

rpm (6.0.0-1) unstable; urgency=medium

  * Drop +dfsg repacking, html docs were removed
  * d/watch: update to version 5
  * New upstream version 6.0.0
  * Drop usermod-root.patch, merged upstream
  * Make rpm-sequoia a requirement
  * Drop patches that modify RPM macros
  * d/control: bump Standards-Version to 4.7.2, no changes
  * Bump dependency on rpm-sequoia
  * Add build dependency on scdoc
  * Backport patch to fix build failure
  * Drop rpm-i18n package, locale files no longer built
  * Install new files
  * Update symbols files for 6.0.0
  * Update d/copyright for removed/renamed files
  * Update Lintian overrides for groff
  * Ignore mangled C++ symbols
  * Update Lintian overrides for test files
  * autopkgtest: avoid test failure and don't verify signature

 -- Luca Boccassi <bluca@debian.org>  Thu, 06 Nov 2025 00:56:55 +0000

=== debian/control ===
Source: rpm
Maintainer: RPM packaging team <team+pkg-rpm@tracker.debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>,
Section: admin
Priority: optional
Build-Depends: debhelper-compat (= 13),
               binutils-dev,
               bzip2,
               cmake,
               debugedit (>= 1:5),
               dh-sequence-python3,
               dh-package-notes,
               gnupg2 [linux-any],
               libacl1-dev,
               libarchive-dev,
               libaudit-dev [linux-any],
               libbz2-dev,
               libcap-dev [linux-any],
               libdbus-1-dev,
               libdw-dev,
               libelf-dev,
               libfsverity-dev [linux-any],
               libgcrypt20-dev,
               liblua5.3-dev,
               liblzma-dev,
               libmagic-dev,
               libpopt-dev,
               libreadline-dev,
               librpm-sequoia-dev (>= 1.9.0~),
               libselinux1-dev [linux-any],
               libsemanage-dev [linux-any],
               libsepol-dev [linux-any],
               libsqlite3-dev,
               libxml2-dev,
               libzstd-dev,
               scdoc,
               7zip,
               pkgconf,
               python3-dev,
               python3-utf8-locale <!nocheck>,
               xz-utils,
               zlib1g-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/pkg-rpm-team/rpm
Vcs-Git: https://salsa.debian.org/pkg-rpm-team/rpm.git
Homepage: https://rpm.org/

Package: rpm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         rpm2cpio,
         debugedit (>= 1:5),
         rpm-common (= ${binary:Version})
Suggests: alien,
          python3,
          elfutils,
          rpmlint,
Description: package manager for RPM
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 On Debian and derived systems it is recommended to use "alien" to
 convert RPM packages into .deb format instead of bypassing the Debian
 package management system by installing them directly with rpm.

Package: rpm2cpio
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         rpm-common (= ${binary:Version})
Description: tool to convert RPM package to CPIO archive
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This package contains tool to convert RPM packages to standard CPIO
 archive.

Package: rpm-common
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: common files for RPM
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This package contains some scripts and default configuration which is
 used by RPM libraries.

Package: librpm10
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         librpmio10 (= ${binary:Version})
Recommends: rpm-common (= ${binary:Version})
Description: RPM shared library
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This library allows programs to make use of an RPM database or RPM packages
 without going through the program rpm.

Package: librpmio10
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: RPM IO shared library
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This library provides basic IO functionality which is used by librpm.

Package: librpmbuild10
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         librpm10 (= ${binary:Version}),
         librpmio10 (= ${binary:Version})
Description: RPM build shared library
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This library provides an interface for building RPM packages.

Package: librpmsign10
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         librpm10 (= ${binary:Version}),
         librpmio10 (= ${binary:Version})
Description: RPM signing shared library
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This library provides an interface for signing RPM packages.

Package: librpm-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: librpm10 (= ${binary:Version}),
         librpmio10 (= ${binary:Version}),
         librpmbuild10 (= ${binary:Version}),
         librpmsign10 (= ${binary:Version}),
         libpopt-dev,
         libbz2-dev,
         zlib1g-dev,
         libxml2-dev,
         libreadline-dev,
         librpm-sequoia-dev [!alpha !hppa !m68k !sh4 !x32],
         libzstd-dev,
         libselinux1-dev [linux-any],
         libsqlite3-dev,
         libgcrypt20-dev,
         libaudit-dev [linux-any],
         libfsverity-dev [linux-any],
         ${misc:Depends}
Description: RPM shared library, development kit
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This package provides the development kit, containing static
 libraries and header files necessary to build programs that use
 librpm.

Package: python3-rpm
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         librpm10 (= ${binary:Version}),
         librpmio10 (= ${binary:Version}),
         librpmbuild10 (= ${binary:Version}),
         librpmsign10 (= ${binary:Version}),
         rpm-common (= ${binary:Version})
Breaks: ${python3:Breaks}
Provides: ${python3:Provides}
Description: Python 3 bindings for RPM
 The RPM Package Manager (RPM) is a command-line driven package
 management system capable of installing, uninstalling, verifying,
 querying, and updating computer software packages.
 .
 This package includes the Python bindings for librpm, allowing Python
 scripts to manipulate RPM packages and the RPM database.
 .
 This package installs the library for Python 3.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# For DEB_HOST_ARCH_OS
include /usr/share/dpkg/architecture.mk

# For proper pkg-config
DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/debhelper/dh_package_notes/package-notes.mk

ifeq (linux,$(DEB_HOST_ARCH_OS))
       configure_flags += -DWITH_CAP=ON -DWITH_SELINUX=ON -DWITH_FSVERITY=ON
else
       configure_flags += -DWITH_CAP=OFF -DWITH_SELINUX=OFF -DWITH_FSVERITY=OFF -DWITH_AUDIT=OFF -DWITH_FAPOLICYD=OFF
endif

configure_flags += \
	-DENABLE_TESTSUITE=OFF \
	-DMKTREE_BACKEND=rootfs \
	-DENABLE_PYTHON=ON \
	-DENABLE_BDB_RO=ON \
	-DENABLE_NDB=ON

override_dh_auto_configure:
	dh_auto_configure -- $(configure_flags)

execute_after_dh_auto_install:
	# Fix permissions
	chmod +x debian/tmp/usr/lib/rpm/rpm.daily

%:
	dh $@

=== debian/watch ===
Version: 5
Template: Github
Owner: rpm-software-management
Project: rpm
Uversion-Mangle: s/(\d)[_\.\-\+]?((?:RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/; s/-release//

## rpm 6.0.1

=== plugins/CMakeLists.txt ===
add_library(prioreset MODULE prioreset.c)
add_library(syslog MODULE syslog.c)

if(WITH_SELINUX)
	add_library(selinux MODULE selinux.c)
	target_link_libraries(selinux PRIVATE PkgConfig::SELINUX)
endif()

if(WITH_DBUS)
	pkg_check_modules(DBUS REQUIRED IMPORTED_TARGET dbus-1)
	pkg_get_variable(dbus-1_DATADIR dbus-1 datadir)
	# Comply with CMP0177
	cmake_path(SET DBUS_DATADIR NORMALIZE "${dbus-1_DATADIR}")
	add_library(systemd_inhibit MODULE systemd_inhibit.c)
	target_link_libraries(systemd_inhibit PRIVATE PkgConfig::DBUS)
	add_library(dbus_announce MODULE dbus_announce.c)
	target_link_libraries(dbus_announce PRIVATE PkgConfig::DBUS)
	install(FILES
	  org.rpm.conf
	  DESTINATION ${DBUS_DATADIR}/dbus-1/system.d/
	)
endif()

if(WITH_IMAEVM)
	add_library(ima MODULE ima.c)
endif()

if(WITH_FAPOLICYD)
	add_library(fapolicyd MODULE fapolicyd.c)
endif()

if(WITH_AUDIT)
	add_library(audit MODULE audit.c)
	target_link_libraries(audit PRIVATE PkgConfig::AUDIT)
endif()

if(WITH_FSVERITY)
	add_library(fsverity MODULE fsverity.c)
	target_link_libraries(fsverity PRIVATE PkgConfig::FSVERITY)
	target_include_directories(fsverity PRIVATE ${CMAKE_SOURCE_DIR}/sign)
endif()

if (HAVE_UNSHARE)
	add_library(unshare MODULE unshare.c)
endif()

get_property(plugins DIRECTORY PROPERTY BUILDSYSTEM_TARGETS)
foreach(plugin ${plugins})
	target_link_libraries(${plugin} PRIVATE librpmio librpm ${Intl_LIBRARIES})
	target_include_directories(${plugin} PRIVATE ${Intl_INCLUDE_DIRS})
	install(TARGETS ${plugin} DESTINATION ${RPM_PLUGINDIR})
	install(FILES macros.transaction_${plugin} DESTINATION ${RPM_MACROSDIR})
endforeach()

=== debian/changelog ===
rpm (6.0.1-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 22 Jan 2026 21:55:32 +0000

rpm (6.0.1-1) unstable; urgency=medium

  * New upstream version 6.0.1
  * Drop luaopen-posix-fix.patch, merged upstream
  * Update symbols files for 6.0.1

 -- Luca Boccassi <bluca@debian.org>  Mon, 15 Dec 2025 16:48:39 +0000

## rpm howto

=== Makefile ===
# This Makefile was automatically created by autotexmake.
# It's used for compiling rpm_howto.tex.
#
MAIN_FILE = rpm_howto.tex
TEX_INCLUDES = rpm_howto.tex 
PS_DPI = 600
L2HOPTS=-dir html/ -split 4 -html_version 3.2,table -short_index

AUX_FILE=$(MAIN_FILE:.tex=.aux)
DVI_FILE=$(MAIN_FILE:.tex=.dvi)
PS_FILE=$(MAIN_FILE:.tex=.ps)

# first target in Makefile is default target
.PHONY:	default
default:	target

html:	dvi psonepass
	latex2html $(L2HOPTS) $(MAIN_FILE)
 
html_fast:	aux
	latex2html $(L2HOPTS) $(MAIN_FILE)
                                                                                
# subdirectories to take into consideration
.PHONY:	SUBDIRS
SUBDIRS:	

.PHONY: auxforce
auxforce:	SUBDIRS
	latex $(MAIN_FILE) || rm $(AUX_FILE)

.PHONY:	aux
aux:	$(AUX_FILE)

$(AUX_FILE): SUBDIRS  $(MAIN_FILE) $(TEX_INCLUDES)
	latex $(MAIN_FILE)

.PHONY:	dviforce
dviforce:	auxforce
	latex $(MAIN_FILE)

.PHONY:	dvithreepass
dvithreepass:	dviforce
	latex $(MAIN_FILE)

.PHONY:	dvi
dvi:	aux $(DVI_FILE)

$(DVI_FILE):	aux $(MAIN_FILE) $(TEX_INCLUDES)
	latex $(MAIN_FILE)

.PHONY:	psonepass
psonepass:	aux
	rm -f $(PS_FILE).tmp
	dvips -D $(PS_DPI) -t a4 $(DVI_FILE) -o $(PS_FILE).tmp
	mv $(PS_FILE).tmp $(PS_FILE)

.PHONY:	pstwopass
pstwopass:	auxforce dviforce ps

.PHONY:	psthreepass
psthreepass:	dviforce ps

.PHONY:	ps
ps:	$(PS_FILE)

$(PS_FILE):	$(DVI_FILE)
	# I use a temp file to make using gv and co in "watch file" mode
	# less painless.
	rm -f $(PS_FILE).tmp
	dvips -D $(PS_DPI) -t a4 $(DVI_FILE) -o $(PS_FILE).tmp
	mv $(PS_FILE).tmp $(PS_FILE)

# specify default target:
target:	psthreepass

# every Makefile should contain a clean target:
.PHONY:	clean
clean:
	@rm -f $(MAIN_FILE:.tex=.log) $(AUX_FILE) $(PS_FILE).tmp
